## cura 5.0.0

=== CMakeLists.txt ===
# Copyright (c) 2022 Ultimaker B.V.
# Cura is released under the terms of the LGPLv3 or higher.

project(cura)
cmake_minimum_required(VERSION 3.18)

include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

set(URANIUM_DIR "${CMAKE_SOURCE_DIR}/../Uranium" CACHE PATH "The location of the Uranium repository")
set(URANIUM_SCRIPTS_DIR "${URANIUM_DIR}/scripts" CACHE PATH "The location of the scripts directory of the Uranium repository")

option(CURA_DEBUGMODE "Enable debug dialog and other debug features" OFF)
if(CURA_DEBUGMODE)
    set(_cura_debugmode "ON")
endif()

option(GENERATE_TRANSLATIONS "Should the translations be generated?" ON)

set(CURA_APP_NAME "cura" CACHE STRING "Short name of Cura, used for configuration folder")
set(CURA_APP_DISPLAY_NAME "Ultimaker Cura" CACHE STRING "Display name of Cura")
set(CURA_VERSION "master" CACHE STRING "Version name of Cura")
set(CURA_BUILDTYPE "" CACHE STRING "Build type of Cura, eg. 'PPA'")
set(CURA_CLOUD_API_ROOT "" CACHE STRING "Alternative Cura cloud API root")
set(CURA_CLOUD_API_VERSION "" CACHE STRING "Alternative Cura cloud API version")
set(CURA_CLOUD_ACCOUNT_API_ROOT "" CACHE STRING "Alternative Cura cloud account API version")
set(CURA_MARKETPLACE_ROOT "" CACHE STRING "Alternative Marketplace location")
set(CURA_DIGITAL_FACTORY_URL "" CACHE STRING "Alternative Digital Factory location")

configure_file(${CMAKE_SOURCE_DIR}/com.ultimaker.cura.desktop.in ${CMAKE_BINARY_DIR}/com.ultimaker.cura.desktop @ONLY)

configure_file(cura/CuraVersion.py.in CuraVersion.py @ONLY)

if(NOT DEFINED Python_VERSION)
    set(Python_VERSION
            3.10
            CACHE STRING "Python Version" FORCE)
    message(STATUS "Setting Python version to ${Python_VERSION}. Set Python_VERSION if you want to compile against an other version.")
endif()
if(APPLE)
    set(Python_FIND_FRAMEWORK NEVER)
endif()
find_package(Python ${Python_VERSION} EXACT REQUIRED COMPONENTS Interpreter)
message(STATUS "Linking and building ${project_name} against Python ${Python_VERSION}")
if(NOT DEFINED Python_SITELIB_LOCAL)
    set(Python_SITELIB_LOCAL
            "${Python_SITELIB}"
            CACHE PATH "Local alternative site-package location to install Cura" FORCE)
endif()

# Tests
include(CuraTests)

if(NOT ${URANIUM_DIR} STREQUAL "")
    set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${URANIUM_DIR}/cmake")
endif()
if(NOT ${URANIUM_SCRIPTS_DIR} STREQUAL "")
    list(APPEND CMAKE_MODULE_PATH ${URANIUM_DIR}/cmake)
    include(UraniumTranslationTools)
    # Extract Strings
    add_custom_target(extract-messages ${URANIUM_SCRIPTS_DIR}/extract-messages ${CMAKE_SOURCE_DIR} cura)
    # Build Translations
    if(${GENERATE_TRANSLATIONS})
        CREATE_TRANSLATION_TARGETS()
    endif()
endif()

install(DIRECTORY resources DESTINATION ${CMAKE_INSTALL_DATADIR}/cura)

include(CuraPluginInstall)

install(FILES cura_app.py DESTINATION ${CMAKE_INSTALL_BINDIR}
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(DIRECTORY cura DESTINATION "${Python_SITELIB_LOCAL}")
install(FILES ${CMAKE_BINARY_DIR}/CuraVersion.py DESTINATION "${Python_SITELIB_LOCAL}/cura/")
if(NOT APPLE AND NOT WIN32)
    install(FILES ${CMAKE_BINARY_DIR}/com.ultimaker.cura.desktop
            DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES ${CMAKE_SOURCE_DIR}/resources/images/cura-icon.png
            DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps/)
    install(FILES com.ultimaker.cura.appdata.xml
            DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
    install(FILES cura.sharedmimeinfo
            DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages/
            RENAME cura.xml )
endif()

=== requirements.txt ===
appdirs==1.4.3
certifi==2019.11.28
cffi==1.14.1
chardet==3.0.4
colorlog
cryptography==3.4.8
decorator==4.4.0
idna==2.8
importlib-metadata==4.10.0
keyring==23.0.1
lxml==4.7.1
mypy==0.740
netifaces==0.10.9
networkx==2.6.2
numpy==1.21.5
numpy-stl==2.10.1
packaging==18.0
pyclipper==1.3.0.post2
pycollada==0.6
pycparser==2.20
pyparsing==2.4.2
PyQt5==5.15.6
PyQt5-sip==12.9.0
pyserial==3.4
pytest
python-dateutil==2.8.0
python-utils==2.3.0
pywin32==303
scipy==1.8.0rc2
sentry-sdk==0.13.5
six==1.12.0
trimesh==3.9.36
twisted==21.2.0
typing
urllib3==1.25.9
zeroconf==0.31.0

=== debian/changelog ===
cura (5.0.0-6) unstable; urgency=medium

  * Actually depend on python3-trimesh.

 -- Christoph Berg <myon@debian.org>  Wed, 05 Feb 2025 10:21:32 +0100

cura (5.0.0-5) unstable; urgency=medium

  * Add forwarded information to patches
  * Depend on python3-trimesh, it is in sid now.
    Closes: #950919
  * Fix unit test assert errors with Python 3.12
    Closes: #1076871
  * Fix "KeyError: material_name"
    Closes: #1085090

 -- Gregor Riepl <onitake@gmail.com>  Tue, 04 Feb 2025 22:47:13 +0100

cura (5.0.0-3) unstable; urgency=medium

  * Get Python3 version to compile against from py3versions -vd.

 -- Christoph Berg <myon@debian.org>  Mon, 03 Jul 2023 19:15:05 +0000

cura (5.0.0-2) unstable; urgency=medium

  * Depend on python3-charon (>= 5.0).

 -- Christoph Berg <myon@debian.org>  Sun, 02 Jul 2023 19:59:57 +0000

cura (5.0.0-1) experimental; urgency=medium

  [ Sebastian Kuzminsky ]
  * New upstream version 5.0.0.
  * Refresh patches.
  * Bump runtime dependencies from qt5 to qt6.
  * Bump versioned dependencies on Ultimaker packages.
  * Add build dependencies needed for tests.
  * Bump build dependency versions for the tests.
  * pq: add patches to delete failing tests.
  * Don't depend on python3-pyqt6.qtopengl, that's in python3-pyqt6 now.

  [ Christoph Berg ]
  * Add dependency on qml6-module-qt-labs-folderlistmodel.

 -- Christoph Berg <myon@debian.org>  Fri, 27 May 2022 17:16:13 +0200

=== debian/control ===
Source: cura
Priority: optional
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders: Gregor Riepl <onitake@gmail.com>,
           Christoph Berg <myon@debian.org>,
Build-Depends: cmake (>= 2.8.12),
               debhelper-compat (= 12),
               dh-python,
               gettext,
               mypy,
               python3,
               python3-arcus (>= 5.0),
               python3-certifi,
               python3-cryptography,
               python3-keyring,
               python3-pyclipper,
               python3-pytest,
               python3-requests,
               python3-savitar (>= 5.0),
               python3-shapely,
               python3-pynest2d (>= 5.0),
               python3-pyqt6,
               python3-pyqt6.qtquick,
               python3-pyqt6.qtsvg,
               python3-uranium (>= 5.0),
               uranium-tools (>= 5.0),
Standards-Version: 4.5.0
Section: misc
Homepage: https://github.com/Ultimaker/Cura
Vcs-Browser: https://salsa.debian.org/3dprinting-team/cura
Vcs-Git: https://salsa.debian.org/3dprinting-team/cura.git

Package: cura
Architecture: all
Depends: cura-engine (>= 1:5.0), cura-engine (<< 1:5.1),
         fonts-open-sans,
         python3-certifi,
         python3-charon (>= 5.0),
         python3-cryptography,
         python3-keyring,
         python3-pyqt6,
         python3-requests,
         python3-savitar (>= 5.0),
         python3-sentry-sdk,
         python3-serial,
         python3-shapely,
         python3-trimesh,
         python3-pynest2d (>= 5.0),
         python3-uranium (>= 5.0),
         python3-zeroconf (>= 0.28),
         qml6-module-qtquick-controls,
         qml6-module-qtquick-dialogs,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window,
         qml6-module-qtqml-workerscript,
         qml6-module-qt-labs-folderlistmodel,
         qt6-qpa-plugins,
         uranium-plugins (>= 5.0),
         fdm-materials (>= 5.0),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
XB-Python3-Version: ${python3:Versions}
Description: GUI G-code generator for 3D printers
 Cura converts digital 3D models (.stl and other formats) into printing
 instructions (G-code) for your 3D printer. It cuts the model into horizontal
 slices (layers), generates toolpaths to fill them and calculates the amount of
 material to be extruded.
 .
 Cura is easy to use for novices and provides over 200 settings to adjust
 for the expert.  It can output G-Code for several series of 3D printers,
 most notably the Ultimaker.
 .
 It provides a graphical user interface.  For batch mode, check out
 cura-engine.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk
# Suppress __pycache__ pollution
export PYTHONDONTWRITEBYTECODE = 1

DEB_URANIUM_DIR ?= /usr/share/uranium

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DURANIUM_DIR=$(DEB_URANIUM_DIR) -DCURA_VERSION=$(DEB_VERSION_UPSTREAM) \
		-DPython_VERSION=$(shell py3versions -vd)

override_dh_clean:
	dh_clean
	# Leftovers from pytest
	rm -rf .cache
	find -name __pycache__ -print0 | xargs -0 rm -rf

override_dh_auto_test:
	mkdir -p debian/home/.local/share/UM
	HOME=$(CURDIR)/debian/home dh_auto_test
